'From Squeak2.8 of 13 June 2000 [No updates present.] on 2 October 2001 at 12:16:46 pm'!
Object subclass: #BooleanCondition
	instanceVariableNames: 'conditions '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AllBoolean'!

!BlockContext methodsFor: 'accessing' stamp: 'SqR 10/2/2001 11:44'!
, aBlockContext

	^BooleanCondition new, self, aBlockContext! !


!BooleanCondition methodsFor: 'accessing' stamp: 'SqR 10/2/2001 11:43'!
, aBlockContext

	conditions add: aBlockContext.
	^self! !

!BooleanCondition methodsFor: 'testing' stamp: 'SqR 10/2/2001 11:50'!
allFalse

	^self return: false ifAnyEvaluatesTo: true! !

!BooleanCondition methodsFor: 'testing' stamp: 'SqR 10/2/2001 11:50'!
allTrue

	^self return: false ifAnyEvaluatesTo: false! !

!BooleanCondition methodsFor: 'testing' stamp: 'SqR 10/2/2001 11:50'!
anyFalse

	^self return: true ifAnyEvaluatesTo: false! !

!BooleanCondition methodsFor: 'testing' stamp: 'SqR 10/2/2001 11:50'!
anyTrue

	^self return: true ifAnyEvaluatesTo: true! !

!BooleanCondition methodsFor: 'testing' stamp: 'SqR 10/2/2001 12:00'!
ifAllFalse: aBlock

	^self allFalse ifTrue: aBlock! !

!BooleanCondition methodsFor: 'testing' stamp: 'SqR 10/2/2001 12:00'!
ifAllTrue: aBlock

	^self allTrue ifTrue: aBlock! !

!BooleanCondition methodsFor: 'testing' stamp: 'SqR 10/2/2001 12:02'!
ifAnyFalse: aBlock

	^self anyFalse ifTrue: aBlock! !

!BooleanCondition methodsFor: 'testing' stamp: 'SqR 10/2/2001 12:02'!
ifAnyTrue: aBlock

	^self anyTrue ifTrue: aBlock! !

!BooleanCondition methodsFor: 'private' stamp: 'SqR 10/2/2001 11:42'!
initialize

	conditions := OrderedCollection new! !

!BooleanCondition methodsFor: 'private' stamp: 'SqR 10/2/2001 11:50'!
return: aBoolean ifAnyEvaluatesTo: aResult

	conditions do: [:each | each value = aResult ifTrue: [^aBoolean]].
	^aBoolean not! !


!BooleanCondition class methodsFor: 'instance creation' stamp: 'SqR 10/2/2001 11:42'!
new

	^super new initialize! !


!BooleanCondition class reorganize!
('instance creation' new)
!

!BooleanCondition reorganize!
('accessing' ,)
('testing' allFalse allTrue anyFalse anyTrue ifAllFalse: ifAllTrue: ifAnyFalse: ifAnyTrue:)
('private' initialize return:ifAnyEvaluatesTo:)
!

